#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

#include <kernel/paging.h>
#include <kernel/tty.h>

struct x86_Page_Directory {
    bool present: 1;
    bool read_write: 1;
    bool user_supervisor: 1;
    bool write_through: 1;
    bool cache_disable: 1;
    bool accesed: 1;
    bool available_2: 1;
    bool page_size: 1;
    uint8_t available_1 : 4;
    uint32_t address : 20; // Multiply by 0x1000
} __attribute__((packed));

struct x86_Page_Table {
    bool present: 1;
    bool read_write: 1;
    bool user_supervisor: 1;
    bool write_through: 1;
    bool cache_disable: 1;
    bool accesed: 1;
    bool dirty: 1;
    bool page_attribute_table: 1;
    bool global: 1;
    uint8_t available_1 : 3;
    uint32_t address : 20; // Multiply by 0x1000
} __attribute__((packed));

extern struct x86_Page_Directory boot_page_directory[1024] __attribute__((aligned(4096)));

static struct x86_Page_Table* get_table(uint16_t index) {
    struct x86_Page_Table* table = (struct x86_Page_Table*)(boot_page_directory[index].address * 0x1000 + 0xC0000000);
    return table;
}

void setup_paging() {
    struct x86_Page_Table* kernel = get_table(768);
    for (int i = 0; i < 1024; i++) {
        if (kernel[i].address != 0) {
            struct x86_Page_Table test = kernel[i];
        }
    }
}

